# file: fibo.py
# author: Bob Muller
#
# CS1101 Computer Science I
#
# This is a small program illustrating the use of recursion to express
# repetitive processes.  It also illustrates an extremely important idea:
# that the "obvious" definition of something often isn't the one that we
# want computationally. The example is the famous Fibonacci Sequence:
#
# 1, 1, 2, 3, 5, 8, 13, ..., F_(n-1) + F_(n-2), ...
#
# badFibo : int -> int                      this version is inefficient
#
def badFibo(n):          
  if n < 3:
    return 1
  else:
    return badFibo(n - 1) + badFibo(n - 2)

# goodFibo : int -> int                     this version is efficient
#
def goodFibo(n):
  def repeat(n, a, b):
    if n == 1:
      return a
    else:
      return repeat(n - 1, b, a + b)
  return repeat(n, 1, 1)
