# file: stripes.py
# author: Bob Muller
#
# CS1101 Computer Science I
#
# This is a small program illustrating the use of recursion to express
# repetitive processes. The example will draw N randomly colored vertical
# stripes in the graphics window.
#
# Usage: Run this program by shipping the code to the Python REPL. It will
# produce a new drawing if you click in the graphics window and then click
# outside of the graphics window.
#
from stddraw import *
import random

# stripes : picture * n -> void
#
def stripes(picture, n):
  width = 1.0 / n
  def repeat(picture, n, width):
    if n > 0:
      color = picture.randomColor()
      y = 0.5
      x = (n - 1) * width + (width / 2.0)
      picture.filledRectangle(x, y, width / 2.0, 0.5, color)
      repeat(picture, n - 1, width)
  repeat(picture, n, width)

def go():
  def responder(event):
    n = random.randint(1, 8)
    stripes(pict, n)
  pict = Picture()
  pict.setW(800)
  pict.setH(800)
  pict.bind('<Button-1>', responder)
  pict.start()

go()
